/*
 * このソースコードは blanco Frameworkによって自動生成されています。
 * Apache Antタスク [BlancoNLpackGeneratorConvertXliff2Properties]のクラス
 */
package blanco.nlpack.generator.task;

import org.apache.tools.ant.BuildException;
import org.apache.tools.ant.Task;

import blanco.nlpack.generator.task.valueobject.BlancoNLpackGeneratorConvertXliff2PropertiesProcessInput;

/**
 * Apache Antタスク [BlancoNLpackGeneratorConvertXliff2Properties]のクラス。
 *
 * [XLIFF対応ツール] Javaアプリケーション(主にEclipseプラグイン) と XLIFFファイル(*.xlf) から言語パックを作成します。<br>
 * このクラスでは、Apache Antタスクで一般的に必要なチェックなどのコーディングを肩代わりします。
 * 実際の処理は パッケージ[blanco.nlpack.generator.task]にBlancoNLpackGeneratorConvertXliff2PropertiesBatchProcessクラスを作成して記述してください。<br>
 * <br>
 * Antタスクへの組み込み例<br>
 * <pre>
 * &lt;taskdef name=&quot;blanconlpackgeneratorconvertxliff2properties&quot; classname=&quot;blanco.nlpack.generator.task.BlancoNLpackGeneratorConvertXliff2PropertiesTask">
 *     &lt;classpath&gt;
 *         &lt;fileset dir=&quot;lib&quot; includes=&quot;*.jar&quot; /&gt;
 *         &lt;fileset dir=&quot;lib.ant&quot; includes=&quot;*.jar&quot; /&gt;
 *     &lt;/classpath&gt;
 * &lt;/taskdef&gt;
 * </pre>
 */
public class BlancoNLpackGeneratorConvertXliff2PropertiesTask extends Task {
    /**
     * [XLIFF対応ツール] Javaアプリケーション(主にEclipseプラグイン) と XLIFFファイル(*.xlf) から言語パックを作成します。
     */
    protected BlancoNLpackGeneratorConvertXliff2PropertiesProcessInput fInput = new BlancoNLpackGeneratorConvertXliff2PropertiesProcessInput();

    /**
     * [XLIFF対応ツール] Javaアプリケーション(主にEclipseプラグイン) と XLIFFファイル(*.xlf) から言語パックを作成します。
     */
    protected boolean fIsFieldSourcedirProcessed = false;

    /**
     * [XLIFF対応ツール] Javaアプリケーション(主にEclipseプラグイン) と XLIFFファイル(*.xlf) から言語パックを作成します。
     */
    protected boolean fIsFieldTargetdirProcessed = false;

    /**
     * [XLIFF対応ツール] Javaアプリケーション(主にEclipseプラグイン) と XLIFFファイル(*.xlf) から言語パックを作成します。
     */
    protected boolean fIsFieldXliffdirProcessed = false;

    /**
     * [XLIFF対応ツール] Javaアプリケーション(主にEclipseプラグイン) と XLIFFファイル(*.xlf) から言語パックを作成します。
     */
    protected boolean fIsFieldTmpdirProcessed = false;

    /**
     * verboseモードで動作させるかどうか。
     *
     * @param arg verboseモードで動作させるかどうか。
     */
    public void setVerbose(final boolean arg) {
        fInput.setVerbose(arg);
    }

    /**
     * verboseモードで動作させるかどうか。
     *
     * @return verboseモードで動作させるかどうか。
     */
    public boolean getVerbose() {
        return fInput.getVerbose();
    }

    /**
     * Antタスクの[sourcedir]アトリビュートのセッターメソッド。
     *
     * 項目番号: 1<br>
     * ソースディレクトリ。*.jarファイルや展開後のEclipseプラグイン。<br>
     *
     * @param arg セットしたい値
     */
    public void setSourcedir(final String arg) {
        fInput.setSourcedir(arg);
        fIsFieldSourcedirProcessed = true;
    }

    /**
     * Antタスクの[sourcedir]アトリビュートのゲッターメソッド。
     *
     * 項目番号: 1<br>
     * ソースディレクトリ。*.jarファイルや展開後のEclipseプラグイン。<br>
     * 必須アトリビュートです。Apache Antタスク上で必ず値が指定されます。<br>
     *
     * @return このフィールドの値
     */
    public String getSourcedir() {
        return fInput.getSourcedir();
    }

    /**
     * Antタスクの[targetdir]アトリビュートのセッターメソッド。
     *
     * 項目番号: 2<br>
     * 言語パックが格納される出力先ディレクトリ。<br>
     *
     * @param arg セットしたい値
     */
    public void setTargetdir(final String arg) {
        fInput.setTargetdir(arg);
        fIsFieldTargetdirProcessed = true;
    }

    /**
     * Antタスクの[targetdir]アトリビュートのゲッターメソッド。
     *
     * 項目番号: 2<br>
     * 言語パックが格納される出力先ディレクトリ。<br>
     * 必須アトリビュートです。Apache Antタスク上で必ず値が指定されます。<br>
     *
     * @return このフィールドの値
     */
    public String getTargetdir() {
        return fInput.getTargetdir();
    }

    /**
     * Antタスクの[xliffdir]アトリビュートのセッターメソッド。
     *
     * 項目番号: 3<br>
     * XLIFFファイルが格納されている入力先ルート・フォルダを指定します。XLIFFファイルは Bundle-SymbolicName ディレクトリ内に格納されることを前提とします。<br>
     *
     * @param arg セットしたい値
     */
    public void setXliffdir(final String arg) {
        fInput.setXliffdir(arg);
        fIsFieldXliffdirProcessed = true;
    }

    /**
     * Antタスクの[xliffdir]アトリビュートのゲッターメソッド。
     *
     * 項目番号: 3<br>
     * XLIFFファイルが格納されている入力先ルート・フォルダを指定します。XLIFFファイルは Bundle-SymbolicName ディレクトリ内に格納されることを前提とします。<br>
     * 必須アトリビュートです。Apache Antタスク上で必ず値が指定されます。<br>
     *
     * @return このフィールドの値
     */
    public String getXliffdir() {
        return fInput.getXliffdir();
    }

    /**
     * Antタスクの[tmpdir]アトリビュートのセッターメソッド。
     *
     * 項目番号: 4<br>
     * テンポラリディレクトリを指定します。無指定の場合にはカレント直下のtmpを用います。<br>
     *
     * @param arg セットしたい値
     */
    public void setTmpdir(final String arg) {
        fInput.setTmpdir(arg);
        fIsFieldTmpdirProcessed = true;
    }

    /**
     * Antタスクの[tmpdir]アトリビュートのゲッターメソッド。
     *
     * 項目番号: 4<br>
     * テンポラリディレクトリを指定します。無指定の場合にはカレント直下のtmpを用います。<br>
     * デフォルト値[tmp]が設定されています。Apache Antタスク上でアトリビュートの指定が無い場合には、デフォルト値が設定されます。<br>
     *
     * @return このフィールドの値
     */
    public String getTmpdir() {
        return fInput.getTmpdir();
    }

    /**
     * Antタスクのメイン処理。Apache Antから このメソッドが呼び出されます。
     *
     * @throws BuildException タスクとしての例外が発生した場合。
     */
    public final void execute() throws BuildException {
        System.out.println("BlancoNLpackGeneratorConvertXliff2PropertiesTask begin.");

        // 項目番号[1]、アトリビュート[sourcedir]は必須入力です。入力チェックを行います。
        if (fIsFieldSourcedirProcessed == false) {
            throw new BuildException("必須アトリビュート[sourcedir]が設定されていません。処理を中断します。");
        }
        // 項目番号[2]、アトリビュート[targetdir]は必須入力です。入力チェックを行います。
        if (fIsFieldTargetdirProcessed == false) {
            throw new BuildException("必須アトリビュート[targetdir]が設定されていません。処理を中断します。");
        }
        // 項目番号[3]、アトリビュート[xliffdir]は必須入力です。入力チェックを行います。
        if (fIsFieldXliffdirProcessed == false) {
            throw new BuildException("必須アトリビュート[xliffdir]が設定されていません。処理を中断します。");
        }

        if (getVerbose()) {
            System.out.println("- verbose:[true]");
            System.out.println("- sourcedir:[" + getSourcedir() + "]");
            System.out.println("- targetdir:[" + getTargetdir() + "]");
            System.out.println("- xliffdir:[" + getXliffdir() + "]");
            System.out.println("- tmpdir:[" + getTmpdir() + "]");
        }

        try {
            // 実際のAntタスクの主処理を実行します。
            // この箇所でコンパイルエラーが発生する場合、BlancoNLpackGeneratorConvertXliff2PropertiesProcessインタフェースを実装して blanco.nlpack.generator.taskパッケージに BlancoNLpackGeneratorConvertXliff2PropertiesProcessImplクラスを作成することにより解決できる場合があります。
            final BlancoNLpackGeneratorConvertXliff2PropertiesProcess proc = new BlancoNLpackGeneratorConvertXliff2PropertiesProcessImpl();
            if (proc.execute(fInput) != BlancoNLpackGeneratorConvertXliff2PropertiesBatchProcess.END_SUCCESS) {
                throw new BuildException("タスクは異常終了しました。");
            }
        } catch (IllegalArgumentException e) {
            if (getVerbose()) {
                e.printStackTrace();
            }
            throw new BuildException(e.getMessage());
        } catch (Exception e) {
            e.printStackTrace();
            throw new BuildException("タスクを処理中に例外が発生しました。処理を中断します。" + e.toString());
        } catch (Error e) {
            e.printStackTrace();
            throw new BuildException("タスクを処理中にエラーが発生しました。処理を中断します。" + e.toString());
        }
    }
}
